.486
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

.data

    hFile            DWORD   0
    FileLength       DWORD   44
    BytesRead        DWORD   0
    BytesWritten     DWORD   0

    DataBuffer       BYTE    64 dup (0)
    FileName         BYTE    "testfile.txt", 0
    szDlgTitle       BYTE    "API File Access...", 0
    szMsgFileSizeErr BYTE    "GetFileSize Failed", 0
    szMsgCreReaErr   BYTE    "Open to Read Failed", 0
    szMsgCreWriErr   BYTE    "Open to Write Failed", 0
    szMsgReadErr     BYTE    "Reading Failed", 0
    szMsgWriteErr    BYTE    "Writing Failed", 0
    szMsgAllDone     BYTE    "All Done", 0

.code

start:

    INVOKE CreateFileA, ADDR FileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        MOV hFile, eax
        MOV edx, eax
        ADD edx, 1
        JZ ProgramCreateReadError

    INVOKE GetFileSize, hFile, ADDR FileLength
        MOV FileLength, 44  
        MOV edx, eax
        ADD edx, 1
        JZ ProgramGetFileSizeError

    INVOKE ReadFile, hFile, ADDR DataBuffer, FileLength, ADDR BytesRead, NULL
        JZ ProgramReadError

    INVOKE CloseHandle, hFile

    LEA eax, DataBuffer
    MOV edx, eax
    ADD edx, FileLength

    DataModifyingLoop:
        ADD dword ptr [eax], 01010101h
        ADD eax, 4
        CMP eax, edx
        JNAE DataModifyingLoop

    INVOKE CreateFile, ADDR FileName, GENERIC_WRITE, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        MOV hFile, eax
        MOV edx, eax
        ADD edx, 1
        JZ ProgramCreateWriteError

    INVOKE WriteFile, hFile, ADDR DataBuffer, FileLength, ADDR BytesWritten, NULL
        JZ ProgramWriteError

    ProgramEnd:
        INVOKE CloseHandle, hFile
        INVOKE MessageBox, NULL, ADDR szMsgAllDone, ADDR szDlgTitle, MB_OK
        INVOKE ExitProcess, NULL


   ProgramGetFileSizeError:
        INVOKE MessageBox, NULL, ADDR szMsgFileSizeErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

   ProgramCreateReadError:
        INVOKE MessageBox, NULL, ADDR szMsgCreReaErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

   ProgramCreateWriteError:
        INVOKE MessageBox, NULL, ADDR szMsgCreWriErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

    ProgramReadError:
        INVOKE MessageBox, NULL, ADDR szMsgReadErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

    ProgramWriteError:
        INVOKE MessageBox, NULL, ADDR szMsgWriteErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

end start
